/*
 * MainFrame.java
 *
 * Created on February 17, 2007, 8:47 PM
 */

package cz.mgn.collab;

import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.Robot;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedWriter;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.net.Socket;
import java.text.DateFormat;
import java.util.Calendar;
import java.util.Date;
import javax.imageio.ImageIO;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JProgressBar;
import javax.swing.Timer;
import cz.mgn.collab.Obrazek;

/**
 *
 * @author  aubrech
 */
public class MainFrame extends javax.swing.JFrame {
    public static final String COMMAND_MESSAGE = "MESSAGE";
    protected Socket socket;
    protected Socket fileSocket;
    protected String nick = "anonymous";
    protected PrintStream outStream;
    protected File cestaKSouboru;
    protected InputStream inStream;
    protected PrintStream fileOutStream;
    protected InputStream fileInStream;
    protected DefaultListModel userModel = new DefaultListModel();
    protected DefaultListModel sharedFiles = new DefaultListModel();
    protected int scrshotNum = 0;
    public BufferedWriter logFile;
    public JButton down1;
    public JButton down2;
    public JButton down3;
    public JProgressBar downBtn;
    public boolean downloading = false;
    public static final String possibleChars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_.(),:_-?=+1234567890#$%& ";
    
    /** Creates new form MainFrame */
    public MainFrame() {
        initComponents();
        down1 = sendScreenshotBtn;
        down2 = sendFileBtn;
        down3 = jButton1;
        downBtn = jProgressBar1;
        userList.setModel(userModel);
        sharedFilesList.setModel(sharedFiles);
        /// fuuuuuuuj, tohle je dirty hack :-(
        new Timer(100, new ActionListener() { public void actionPerformed(ActionEvent e) { checkConnection();checkFileConnection();}}).start();
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        sendFileBtn = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        sendScreenshotBtn = new javax.swing.JButton();
        quitBtn = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        userList = new javax.swing.JList();
        statusLbl = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        jSplitPane1 = new javax.swing.JSplitPane();
        jPanel3 = new javax.swing.JPanel();
        sendBtn = new javax.swing.JButton();
        jScrollPane3 = new javax.swing.JScrollPane();
        messageTxt = new javax.swing.JTextArea();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jScrollPane2 = new javax.swing.JScrollPane();
        logArea = new javax.swing.JTextArea();
        jPanel4 = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        sharedFilesList = new javax.swing.JList();
        jPanel5 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jPanel6 = new javax.swing.JPanel();
        jScrollPane5 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jPanel7 = new javax.swing.JPanel();
        jProgressBar1 = new javax.swing.JProgressBar();
        jLabel1 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Collab Client");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        jPanel1.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 2, 2));

        sendFileBtn.setMnemonic('f');
        sendFileBtn.setText("send file...");
        sendFileBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sendFileBtnActionPerformed(evt);
            }
        });

        jPanel1.add(sendFileBtn);

        jButton3.setMnemonic('r');
        jButton3.setText("share file...");
        jButton3.setEnabled(false);
        jPanel1.add(jButton3);

        sendScreenshotBtn.setMnemonic('o');
        sendScreenshotBtn.setText("send screenshot");
        sendScreenshotBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sendScreenshotBtnActionPerformed(evt);
            }
        });

        jPanel1.add(sendScreenshotBtn);

        quitBtn.setMnemonic('q');
        quitBtn.setText("quit");
        quitBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                quitBtnActionPerformed(evt);
            }
        });

        jPanel1.add(quitBtn);

        getContentPane().add(jPanel1, java.awt.BorderLayout.NORTH);

        userList.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        userList.setPreferredSize(new java.awt.Dimension(60, 85));
        jScrollPane1.setViewportView(userList);

        getContentPane().add(jScrollPane1, java.awt.BorderLayout.WEST);

        statusLbl.setText(" ");
        getContentPane().add(statusLbl, null);

        jPanel2.setLayout(new java.awt.BorderLayout());

        jSplitPane1.setDividerLocation(200);
        jSplitPane1.setDividerSize(8);
        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane1.setContinuousLayout(true);
        jSplitPane1.setOneTouchExpandable(true);
        jPanel3.setLayout(new java.awt.BorderLayout());

        sendBtn.setMnemonic('s');
        sendBtn.setText("send");
        sendBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sendBtnActionPerformed(evt);
            }
        });

        jPanel3.add(sendBtn, java.awt.BorderLayout.EAST);

        messageTxt.setColumns(20);
        messageTxt.setRows(5);
        messageTxt.addAncestorListener(new javax.swing.event.AncestorListener() {
            public void ancestorMoved(javax.swing.event.AncestorEvent evt) {
            }
            public void ancestorAdded(javax.swing.event.AncestorEvent evt) {
            }
            public void ancestorRemoved(javax.swing.event.AncestorEvent evt) {
                messageTxtAncestorRemoved(evt);
            }
        });
        messageTxt.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                messageTxtKeyPressed(evt);
            }
            public void keyReleased(java.awt.event.KeyEvent evt) {
                messageTxtKeyReleased(evt);
            }
        });

        jScrollPane3.setViewportView(messageTxt);

        jPanel3.add(jScrollPane3, java.awt.BorderLayout.CENTER);

        jSplitPane1.setBottomComponent(jPanel3);

        logArea.setColumns(20);
        logArea.setEditable(false);
        logArea.setLineWrap(true);
        logArea.setRows(5);
        jScrollPane2.setViewportView(logArea);

        jTabbedPane1.addTab("Chat", jScrollPane2);

        jPanel4.setLayout(new java.awt.BorderLayout());

        sharedFilesList.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jScrollPane4.setViewportView(sharedFilesList);

        jPanel4.add(jScrollPane4, java.awt.BorderLayout.CENTER);

        jButton1.setText("download");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jPanel5.add(jButton1);

        jButton2.setText("delete");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jPanel5.add(jButton2);

        jPanel4.add(jPanel5, java.awt.BorderLayout.SOUTH);
        jPanel5.getAccessibleContext().setAccessibleParent(jScrollPane4);

        jTabbedPane1.addTab("Shared Files", jPanel4);

        jTextArea1.setColumns(20);
        jTextArea1.setRows(5);
        jTextArea1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jTextArea1KeyPressed(evt);
            }
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jTextArea1KeyTyped(evt);
            }
        });

        jScrollPane5.setViewportView(jTextArea1);

        org.jdesktop.layout.GroupLayout jPanel6Layout = new org.jdesktop.layout.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane5, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 348, Short.MAX_VALUE)
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane5, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 172, Short.MAX_VALUE)
        );
        jTabbedPane1.addTab("Tabule", jPanel6);

        jProgressBar1.setStringPainted(true);

        jLabel1.setText("Stav downloadu: ");

        org.jdesktop.layout.GroupLayout jPanel7Layout = new org.jdesktop.layout.GroupLayout(jPanel7);
        jPanel7.setLayout(jPanel7Layout);
        jPanel7Layout.setHorizontalGroup(
            jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel7Layout.createSequentialGroup()
                .addContainerGap(110, Short.MAX_VALUE)
                .add(jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel1)
                    .add(jProgressBar1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(90, 90, 90))
        );
        jPanel7Layout.setVerticalGroup(
            jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel7Layout.createSequentialGroup()
                .add(57, 57, 57)
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jProgressBar1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(74, Short.MAX_VALUE))
        );
        jTabbedPane1.addTab("Down/Up Status", jPanel7);

        jSplitPane1.setTopComponent(jTabbedPane1);

        jPanel2.add(jSplitPane1, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-418)/2, (screenSize.height-329)/2, 418, 329);
    }// </editor-fold>//GEN-END:initComponents

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        try {
            logFile.close();
        } catch (Exception ex) {
            System.err.println("Unable to close logfile...");
        }
    }//GEN-LAST:event_formWindowClosing
    
    private void messageTxtKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_messageTxtKeyReleased
        String zprava = messageTxt.getText().trim();
        
        if (zprava.length() > 0){
            if(evt.getKeyCode() == 10){
                sendString("MESSAGE",nick + ": " +zprava);
                messageTxt.setText("");
                messageTxt.requestFocus();
            }
        }
    }//GEN-LAST:event_messageTxtKeyReleased
    
    private void messageTxtAncestorRemoved(javax.swing.event.AncestorEvent evt) {//GEN-FIRST:event_messageTxtAncestorRemoved
// TODO add your handling code here:
    }//GEN-LAST:event_messageTxtAncestorRemoved
    
    private void jTextArea1KeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextArea1KeyPressed
        send("TABLE INSERT \""+evt.getKeyChar()+"\"");// TODO add your handling code here:
    }//GEN-LAST:event_jTextArea1KeyPressed
    
    private void jTextArea1KeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextArea1KeyTyped
        
    }//GEN-LAST:event_jTextArea1KeyTyped
    
    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        String deletedFile = String.valueOf(sharedFilesList.getSelectedValue());
        if (deletedFile.length() > 1){
            deletedFile = deletedFile.substring(0,deletedFile.lastIndexOf("("));
            send("DELETEFILE "+deletedFile);
        }
    }//GEN-LAST:event_jButton2ActionPerformed
    
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        Object soubor = sharedFilesList.getSelectedValue();
        if (soubor != null){
            String souborStr = soubor.toString();
            int zavorka1 = souborStr.lastIndexOf("(");
            int zavorka2 = souborStr.lastIndexOf(")");
            String nazev = souborStr.substring(0,zavorka1);
            down3.setEnabled(false);
            jLabel1.setText("Stav downloadu:");
            fileStreamSend("GETFILE \"" + nazev + "\" " + souborStr.substring(zavorka1+1,zavorka2));
        }
        
    }//GEN-LAST:event_jButton1ActionPerformed
    
    private void sendScreenshotBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sendScreenshotBtnActionPerformed
        try {
            setVisible(false);
            Toolkit toolkit = Toolkit.getDefaultToolkit();
            Dimension screenSize = toolkit.getScreenSize();
            Rectangle screenRect = new Rectangle(screenSize);
            Robot robot = new Robot();
            BufferedImage image = robot.createScreenCapture(screenRect);
            setVisible(true);
            ByteArrayOutputStream inMemory = new ByteArrayOutputStream();
            // save captured image to PNG file
            ImageIO.write(image, "png", inMemory);
            // send the screenshot to the server
            fileOutStream.print("FILE \"screenshot-" + nick + "-"+scrshotNum + ".png\" " + inMemory.size() + "\n");
            scrshotNum++;
            ByteArrayInputStream inMemoryInput = new ByteArrayInputStream(inMemory.toByteArray());
            jLabel1.setText("Stav uploadu:");
            
            jTabbedPane1.setSelectedIndex(3);
            SendingThread st = new SendingThread(this, fileOutStream, inMemoryInput, inMemory.size());
            st.start();
            
        } catch (Exception ex) {
            ex.printStackTrace();
            JOptionPane.showMessageDialog(this, "Unable to send screenshot, "+ex.getMessage(),"Error", JOptionPane.ERROR_MESSAGE);
        }
        
    }//GEN-LAST:event_sendScreenshotBtnActionPerformed
    
    private void sendFileBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sendFileBtnActionPerformed
        JFileChooser jfc = new JFileChooser(new File("."));
        jfc.showOpenDialog(this);
        cestaKSouboru = jfc.getSelectedFile();
        
        for(int i2 = 0; i2 < cestaKSouboru.getName().length();i2++){
            if (!(possibleChars.contains(String.valueOf(cestaKSouboru.getName().charAt(i2))))){
                JOptionPane.showMessageDialog(null,"Nazev souboru smi pouze obsahovat pismena a znaky anglicke klavesnice");
                return;
            }
        }
        jLabel1.setText("Stav uploadu:");
        
        try{
            InputStream fis = new BufferedInputStream(new FileInputStream(cestaKSouboru),64*1024);
            fileOutStream.print("FILE \"" + cestaKSouboru.getName() + "\" " + cestaKSouboru.length() + "\n");
            OutputStream bos = new BufferedOutputStream(fileOutStream,64*1024);
            
            jTabbedPane1.setSelectedIndex(3);
            SendingThread st = new SendingThread(this, bos, fis, Integer.valueOf(String.valueOf(cestaKSouboru.length())));
            st.start();
            
        } catch(Exception e){
            //System.out.print(printStrackTrace);
        }
    }//GEN-LAST:event_sendFileBtnActionPerformed
    
    private void messageTxtKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_messageTxtKeyPressed
        
    }//GEN-LAST:event_messageTxtKeyPressed
    
    private void sendBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sendBtnActionPerformed
        String zprava = messageTxt.getText().trim();
        if (zprava.length() > 0){
            sendString("MESSAGE",nick + ": " +zprava);
            messageTxt.setText("");
            messageTxt.requestFocus();
        }
    }//GEN-LAST:event_sendBtnActionPerformed
    
    private void quitBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_quitBtnActionPerformed
        this.setVisible(false);
        System.exit(0);
    }//GEN-LAST:event_quitBtnActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                MainFrame mainFr = new MainFrame();
                ConnectFrame conFr = new ConnectFrame();
                conFr.setMainFrame(mainFr);
                conFr.setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JProgressBar jProgressBar1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextArea logArea;
    private javax.swing.JTextArea messageTxt;
    private javax.swing.JButton quitBtn;
    private javax.swing.JButton sendBtn;
    private javax.swing.JButton sendFileBtn;
    private javax.swing.JButton sendScreenshotBtn;
    private javax.swing.JList sharedFilesList;
    private javax.swing.JLabel statusLbl;
    private javax.swing.JList userList;
    // End of variables declaration//GEN-END:variables
    
    public void setSocket(Socket socket) {
        this.socket = socket;
        initialiseConnection();
    }
    
    public void setFileSocket(Socket fileSocket) {
        this.fileSocket = fileSocket;
    }
    
    /** retreive all the initial necessary information from the server
     */
    private void initialiseConnection() {
        try {
            
            
            try{
                String nazevSouboru = new Date().toString();
                logFile = new BufferedWriter(new FileWriter("logs/"+nazevSouboru+".log"));
            } catch (Exception ex) {
                System.out.println("Unable to create log file....");
            }
            outStream = new PrintStream(new BufferedOutputStream(socket.getOutputStream(),64*1024));
            inStream = new BufferedInputStream(socket.getInputStream(),64*1024);
            
            fileOutStream = new PrintStream(new BufferedOutputStream(fileSocket.getOutputStream(),64*1024));
            fileInStream = new BufferedInputStream(fileSocket.getInputStream(),64*1024);
            
            System.out.println("sending my nick "+nick);
            send("MYNICK "+nick);
            
            // read list of users
            System.out.println("requesting other nicks");
            send("GETUSERS");
            String user;
            while((user=getRow()).length()>0) {
                System.out.println("adding "+user);
                if (user.startsWith("NEWNICK ")){
                    userModel.addElement(user.substring(8,user.length()));
                }
            }
            
            send("REFILES");
            System.out.println("sending request for uploaded files");
            String fileList;
            while ((fileList=getRow()).length()>0) {
                if (fileList.startsWith("UP-SHARED FILE")){
                    String name = fileList.substring(fileList.indexOf('"')+1,fileList.lastIndexOf('"'));
                    int len = Integer.parseInt(fileList.substring(fileList.lastIndexOf(' ')).trim());
                    // ensure it doesn't contain bad characters
                    sharedFiles.addElement(name + "(" + len+ ")");
                    System.out.println("Recieve a name of file: " + name);
                }
            }
            
            send("REFRESH");
            
            System.out.println("initialisation successfull");
            logArea.append("System: Conected!\n");
            
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
    
    /** send command to the server
     */
    protected synchronized void send(String cmd) {
        outStream.print(cmd+"\n");
        outStream.flush();
    }
    
    protected synchronized void fileStreamSend(String cmd) {
        fileOutStream.print(cmd+"\n");
        fileOutStream.flush();
    }
    
    /** read data from the server. First four bytes is the lenght of the file
     */
    protected synchronized String getRow() throws IOException {
        StringBuffer returned = new StringBuffer();
        int b;
        while((b=inStream.read())>=0 && b!='\n') {
            returned.append((char)b);
        }
        //String returned = inStream.readLine();
        System.out.println("rcvd: "+returned);
        return returned.toString();
    }
    
    public void setStatus(String txt) {
        statusLbl.setText(txt);
    }
    
    public void setNick(String nick) {
        this.nick = nick;
    }
    
    protected void sendString(String cmd, String content) {
        send(cmd + " " + content.length());// +  "//" +content);
        send(content);
        // tohle neni dobre reseni -- co kdyz v textu bude !CMD_EOM!?
        //send("!CMD_EOM!");
        outStream.flush();
    }
    
    public synchronized void checkFileConnection() {
        try {
            if((fileInStream == null || fileInStream.available()==0 || downloading == true))
                return;
            
            StringBuffer fileRadekBuf = new StringBuffer();
            int i = 1;
            fileRadekBuf.setLength(0);
            
            while ((i = fileInStream.read()) != '\n' && i > 0){
                fileRadekBuf.append((char)i);
                //System.out.println("buffer so far: "+radekBuf);
            }
            
            String fileRadek = fileRadekBuf.toString().trim();
            System.out.println("file input data: "+fileRadek);
            
            if (fileRadek.startsWith("FILE ")){
                String name = fileRadek.substring(fileRadek.indexOf('"')+1,fileRadek.lastIndexOf('"'));
                int len = Integer.parseInt(fileRadek.substring(fileRadek.lastIndexOf(' ')).trim());
                File file = new File("sharedfiles/"+name);
                OutputStream os = new BufferedOutputStream(new FileOutputStream(file));
                
                downloading = true;
                
                jTabbedPane1.setSelectedIndex(3);
                System.out.println("Start SendingThread...");
                SendingThread st = new SendingThread(this, os, fileInStream, len, name);
                st.start();
                System.out.println("Sending thread stops...");
                
            }
            
            
            
        } catch (IOException ex) {
            ex.printStackTrace();
        }
        
    }
    
    public void checkConnection() {
        try {
            if((inStream==null || inStream.available()==0))
                return; // nothing to do
            //System.out.println("aaa, some message!");
            StringBuffer radekBuf = new StringBuffer();
            
            int i = 1;
            radekBuf.setLength(0);
            // clear buffer
            // read line
            while ((i = inStream.read()) != '\n' && i > 0){
                radekBuf.append((char)i);
                //System.out.println("buffer so far: "+radekBuf);
            }
            
            String radek = radekBuf.toString().trim();
            
            System.out.println("input data: "+radek);
            
            if(radek.equals("")) {
            } else if (radek.startsWith(COMMAND_MESSAGE)){
                // zjisti delku dat
                int len = Integer.parseInt(radek.substring(COMMAND_MESSAGE.length()).trim());
                StringBuffer msg = new StringBuffer();
                for(int y=0;y<len;y++) {
                    msg.append((char)inStream.read());
                }
                System.out.println("Dostal jsem zpravu: "+msg);
                String time = DateFormat.getTimeInstance().format(new Date());
                logArea.append("("+time+") "+msg.toString()+"\n");
                logArea.setSelectionEnd(logArea.getLineCount());
                
                try{
                    logFile.write(time+": "+msg.toString()+"\r\n");
                    logFile.flush();
                } catch (Exception ex){
                   
                }
            } else if (radek.trim().startsWith("GETUSERS")){
                send("GETUSERS");
                String user2;
                userModel.clear();
                while((user2=getRow()).length()>0) {
                    System.out.println("adding "+user2);
                    if (user2.startsWith("NEWNICK ")){
                        userModel.addElement(user2.substring(8,user2.length()));
                    }
                }
                sharedFiles.clear();
                send("REDELFILES");
            } else if (radek.startsWith("SENDFILELIST")){
                sharedFiles.clear();
            } else if (radek.equals("WASDELETED")){
                sharedFiles.clear();
                send("REDELFILES");
            } else if (radek.startsWith("TABLE INSERT")){
                char word = radek.charAt(14);
                ;
                jTextArea1.insert(String.valueOf(word),jTextArea1.getText().length());
                
            } else if (radek.startsWith("SHARED FILE")){
                // zjisti jmeno a delku dat
                String name = radek.substring(radek.indexOf('"')+1,radek.lastIndexOf('"'));
                int len = Integer.parseInt(radek.substring(radek.lastIndexOf(' ')).trim());
                // ensure it doesn't contain bad characters
                sharedFiles.addElement(name + "(" + len+ ")");
                String time = DateFormat.getTimeInstance().format(new Date());
                logArea.append("("+time+") "+ "System: New file uploaded:"+name +"\n");
                logArea.setSelectionEnd(logArea.getLineCount());
            } else if (radek.startsWith("UP-SHARED FILE")){
                // zjisti jmeno a delku dat
                String name = radek.substring(radek.indexOf('"')+1,radek.lastIndexOf('"'));
                int len = Integer.parseInt(radek.substring(radek.lastIndexOf(' ')).trim());
                // ensure it doesn't contain bad characters
                sharedFiles.addElement(name + "(" + len+ ")");
                
            }
        } catch (IOException ex) {
            ex.printStackTrace();
            JOptionPane.showMessageDialog(this,"Connection to the server has been lost!","Connection Error",JOptionPane.ERROR_MESSAGE);
        } // nothing to do
    }
}
